#include	"3DSModel.h"

bool mgc3DSModel::fLoad3DS( char *chFileName )
{
	ifstream	ifs;
	USHORT		usR;
	USHORT		i, j;

	ifs.open( chFileName,ios::in | ios::binary | ios::beg );
		
	while( !ifs.eof() )
	{
		ifs.read( ( char * )&usR, 2 );

		switch( usR )
		{
		case ID_VERTEX_3DS:
			ifs.seekg( ifs.tellg() + 4 );
			ifs.read( ( char * )&usCountVer, 2 );

			vec = new c_vector3d[ usCountVer ];

			for( i = 0; i < usCountVer; i ++ )
				ifs.read( ( char * )&vec[ i ], 12 );

			break;
			
		case ID_TRIANGLE_3DS:
			ifs.seekg( ifs.tellg() + 4 );
			ifs.read( ( char * )&usCountTri, 2 );

			ind = new mgcIndex3i[ usCountTri ];

			for( i = 0; i < usCountTri; i ++ )
			{
				ifs.read( ( char * )&ind[ i ], 6 );
				ifs.seekg( ifs.tellg() + 2 );
			}

			break;

		case ID_TEXCOORD_3DS:
			ifs.seekg( ifs.tellg() + 4 );
			ifs.read( ( char * )&usCountCor, 2 );

			cor = new c_vector2d[ usCountCor ];

			for( i = 0; i < usCountCor; i ++ )
			{
				ifs.read( ( char * )&cor[ i ], 8 );
			}

			break;

		case ID_FACEMAT_3DS:
			ifs.seekg( ifs.tellg() + 4 );			

			j = 0;
			while( 1 )
			{
				ifs.read( ( char * )&mat[ iCountMaterials ].chMatName[ j ], 1 );
				if( mat[ iCountMaterials ].chMatName[ j ] == 0x00 )
				{
					break;
				}

				j ++;
			}

			ifs.read( ( char * )&mat[ iCountMaterials ].usCountTri, 2 );

			mat[ iCountMaterials ].usInd = new USHORT[ mat[ iCountMaterials ].usCountTri ];
			for( i = 0; i < mat[ iCountMaterials ].usCountTri; i ++ )
			{
				ifs.read( ( char * )&mat[ iCountMaterials ].usInd[ i ], 2 );
			}

			iCountMaterials ++;
			
			break;

		case ID_MAPFILE_3DS:
			ifs.seekg( ifs.tellg() + 4 );
			
			j = 0;
			while( 1 )
			{
				ifs.read( ( char * )&mat[ iCountTextures ].chTexName[ j ], 1 );
				if( mat[ iCountTextures ].chTexName[ j ] == 0x00 )
				{
					break;
				}

				j ++;
			}

			mat[ iCountTextures ].tex.tLoadBMP( mat[ iCountTextures ].chTexName );

			iCountTextures ++;

			break;

		default:
			ifs.seekg( ifs.tellg() - 1 );

			break;
		}
	}

	ifs.close();

	return		true;
}

void mgc3DSModel::fRender( void )
{
	int		i, j;

	glEnable( GL_TEXTURE_2D );
	glEnable( GL_DEPTH_TEST );

	for( j = 0; j < iCountMaterials; j ++ )
	{

	mat[ j ].tex.tCall();

	glBegin(GL_TRIANGLES);

		for ( i = 0; i < mat[ j ].usCountTri; i ++ )
		{
			glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );

			glTexCoord2f( cor[ ind[ mat[ j ].usInd[ i ] ].i[ 0 ] ].x, 
				          cor[ ind[ mat[ j ].usInd[ i ] ].i[ 0 ] ].y );
			glVertex3f( vec[ ind[ mat[ j ].usInd[ i ] ].i[ 0 ] ].x, 
				        vec[ ind[ mat[ j ].usInd[ i ] ].i[ 0 ] ].y, 
						vec[ ind[ mat[ j ].usInd[ i ] ].i[ 0 ] ].z );
			glTexCoord2f( cor[ ind[ mat[ j ].usInd[ i ] ].i[ 1 ] ].x, 
				          cor[ ind[ mat[ j ].usInd[ i ] ].i[ 1 ] ].y );
			glVertex3f( vec[ ind[ mat[ j ].usInd[ i ] ].i[ 1 ] ].x, 
				        vec[ ind[ mat[ j ].usInd[ i ] ].i[ 1 ] ].y, 
						vec[ ind[ mat[ j ].usInd[ i ] ].i[ 1 ] ].z );
			glTexCoord2f( cor[ ind[ mat[ j ].usInd[ i ] ].i[ 2 ] ].x, 
				          cor[ ind[ mat[ j ].usInd[ i ] ].i[ 2 ] ].y );
			glVertex3f( vec[ ind[ mat[ j ].usInd[ i ] ].i[ 2 ] ].x, 
				        vec[ ind[ mat[ j ].usInd[ i ] ].i[ 2 ] ].y, 
						vec[ ind[ mat[ j ].usInd[ i ] ].i[ 2 ] ].z );
		} 

	glEnd();

	}

	glDisable( GL_DEPTH_TEST );
	glDisable( GL_TEXTURE_2D );
}

mgc3DSModel::mgc3DSModel( void )
{
}

mgc3DSModel::~mgc3DSModel( void )
{
	delete [] ind;
	delete [] cor;
	delete [] vec;
}