#include	"MGFModel.h"

mgcMGFModel::mgcMGFModel( void )
{

}

mgcMGFModel::~mgcMGFModel( void )
{
	delete [] triData;
	delete [] matData;
	delete [] aniRoot.joiData;
	delete [] bonData;
	delete [] aniData.frmData;
	delete [] vRenPos;
}

void mgcMGFModel::funCalculateMatrix( strcMGFFrame ani )
{
	int		i;

	for( i = 0; i < iCountJoints; i ++ )
	{
		bonData[ i ].mAbs.clClear();

		bonData[ i ].mRel.clCreateXYZRot( - ani.joiData[ i ].vRot.x,
			- ani.joiData[ i ].vRot.y,
			- ani.joiData[ i ].vRot.z );

		bonData[ i ].mRel.m[ 3  ] = ani.joiData[ i ].vPos.x;
		bonData[ i ].mRel.m[ 7  ] = ani.joiData[ i ].vPos.y;
		bonData[ i ].mRel.m[ 11 ] = ani.joiData[ i ].vPos.z;

		if( ani.joiData[ i ].iParent != - 1 )
		{
			bonData[ i ].mAbs = bonData[ ani.joiData[ i ].iParent ].mAbs * bonData[ i ].mRel;
		}
		else
		{
			bonData[ i ].mAbs = bonData[ i ].mRel;
		}
	}
}

void mgcMGFModel::funCollapse( void )
{
	int		i, j;

	for( i = 0; i < iCountTriangles; i ++ )
	{
		for( j = 0; j < 3; j ++ )
		{
			vRenPos[ i * 3 + j ] = triData[ i ].v[ j ].vPos;
			vRenPos[ i * 3 + j ].VecInvMatrix( bonData[ triData[ i ].v[ j ].iBone ].mAbs );
		//	triData[ i ].v[ j ].vPos.VecInvMatrix( bonData[ triData[ i ].v[ j ].iBone ].mAbs );
		}
	}
}

void mgcMGFModel::funCreate( void )
{
	int		i, j;

	for( i = 0; i < iCountTriangles; i ++ )
	{
		for( j = 0; j < 3; j ++ )
		{
			vRenPos[ i * 3 + j ].VecMatrix( bonData[ triData[ i ].v[ j ].iBone ].mAbs );
		//	triData[ i ].v[ j ].vPos.VecMatrix( bonData[ triData[ i ].v[ j ].iBone ].mAbs );
		}
	}
}

void mgcMGFModel::funLoadModel( char * chFileName )
{
	FILE	* inpfile;
	int		i, j;
	char	chLine[ 256 ];

	inpfile = fopen( chFileName, "r" );

	if( inpfile )
	{
		fscanf( inpfile, "%i", &iCountTriangles );
		triData = new strcMGFTriangle[ iCountTriangles ];
		
		vRenPos = new c_vector3d[ iCountTriangles * 3 ];

		for( i = 0;i < iCountTriangles; i ++ )
		{
			for( j = 0; j < 3; j ++ )
			{
				fscanf( inpfile, "%i %f %f %f %f %f", 
					&triData[ i ].v[ j ].iBone,
					&triData[ i ].v[ j ].vPos.x,
					&triData[ i ].v[ j ].vPos.y,
					&triData[ i ].v[ j ].vPos.z,
					&triData[ i ].v[ j ].vTex.x,
					&triData[ i ].v[ j ].vTex.y );
			}
		}

		fscanf( inpfile, "%i", &iCountMaterials );
		matData = new strcMGFMaterial[ iCountMaterials ];

		for( j = 0; j < iCountMaterials; j ++ )
		{
			memset( chLine, 0, 256 );
			fscanf( inpfile, "%s", &chLine );
			matData[ j ].tex.tLoadBMP( chLine );
			fscanf( inpfile, "%i", &matData[ j ].iCountTriangles );
			matData[ j ].iInd = new int[ matData[ j ].iCountTriangles ];

			for( i = 0; i < matData[ j ].iCountTriangles; i ++ )
			{
				fscanf( inpfile, "%i", &matData[ j ].iInd[ i ] );
			}
		}

		fscanf( inpfile, "%i", &iCountJoints );
		aniRoot.joiData = new strcMGFJoint[ iCountJoints ];
		bonData = new strcMGFBone [ iCountJoints ];

		for( i = 0; i < iCountJoints; i ++ )
		{
			fscanf( inpfile, "%i %f %f %f %f %f %f", 
				&aniRoot.joiData[ i ].iParent,
				&aniRoot.joiData[ i ].vPos.x, 
				&aniRoot.joiData[ i ].vPos.y, 
				&aniRoot.joiData[ i ].vPos.z,
				&aniRoot.joiData[ i ].vRot.x, 
				&aniRoot.joiData[ i ].vRot.y, 
				&aniRoot.joiData[ i ].vRot.z );
		}

		fclose( inpfile );
	}
}

void mgcMGFModel::funLoadAnimation( char * chFileName )
{
	FILE	* inpfile;
	int		i, j;
	char	chLine[ 256 ];

	inpfile = fopen( chFileName, "r" );

	if( inpfile )
	{
		fscanf( inpfile, "%i", &j );
		fscanf( inpfile, "%i", &aniData.iCountFrames );
		aniData.frmData = new strcMGFFrame[ aniData.iCountFrames ];

		for( i = 0; i < aniData.iCountFrames; i ++ )
		{
			iCountJoints = j;
			aniData.frmData[ i ].joiData = new strcMGFJoint[ j ];
		}

		for( i = 0; i < aniData.iCountFrames; i ++ )
		{
			for( j = 0; j < iCountJoints; j ++ )
			{
				aniData.frmData[ i ].joiData[ j ].iParent = aniRoot.joiData[ j ].iParent;
				fscanf( inpfile, "%f %f %f %f %f %f", 
					&aniData.frmData[ i ].joiData[ j ].vPos.x,
					&aniData.frmData[ i ].joiData[ j ].vPos.y,
					&aniData.frmData[ i ].joiData[ j ].vPos.z,
					&aniData.frmData[ i ].joiData[ j ].vRot.x,
					&aniData.frmData[ i ].joiData[ j ].vRot.y,
					&aniData.frmData[ i ].joiData[ j ].vRot.z );
			}
		}

		for( i = 0; i < aniData.iCountFrames; i ++ )
		{
			aniData.frmData[ i ].joiData[ 0 ].vPos.x = 0;
			aniData.frmData[ i ].joiData[ 0 ].vPos.y = 0;
			aniData.frmData[ i ].joiData[ 0 ].vPos.z = 0;
		}

		fclose( inpfile );
	}
}

void mgcMGFModel::funSetAnimation( int iCurrentFrame, float fTimePerFrame )
{
	this->iCurrentFrame = iCurrentFrame;
	this->fTimePerFrame = fTimePerFrame;
}

void mgcMGFModel::funRender( float fDelTime )
{
	int		i, j, k;

	if( bPlayAnimation )
	{ 
		fTempTime += fDelTime;
	}

	if( fTempTime > fTimePerFrame )
	{
		iCurrentFrame ++;

		if( iCurrentFrame >= aniData.iCountFrames )
		{
			iCurrentFrame = 0;
		}

		fTempTime = 0.0f;
	}

	glEnable( GL_TEXTURE_2D );
	glEnable( GL_DEPTH_TEST );
	glEnable( GL_CULL_FACE );
	glCullFace( GL_BACK );

	glColor4f( 1.0f, 1.0f, 1.0f, 1.0f );

	funCalculateMatrix( aniRoot );
	funCollapse();
	funCalculateMatrix( aniData.frmData[ iCurrentFrame ] );
	funCreate();

	for( i = 0; i < iCountMaterials; i ++ )	
	{
		matData[ i ].tex.tCall();

		glBegin( GL_TRIANGLES );

		for( j = 0; j < matData[ i ].iCountTriangles; j ++ )
		{
			for( k = 0; k < 3; k ++ )
			{
				glTexCoord2fv ( ( float * )&triData[ matData[ i ].iInd[ j ] ].v[ k ].vTex );
				glVertex3fv   ( ( float * )&vRenPos[ matData[ i ].iInd[ j ] * 3 + k ] );
			}
		}

		glEnd();
	}

	glDisable( GL_CULL_FACE );
	glDisable( GL_DEPTH_TEST );
	glDisable( GL_TEXTURE_2D );
	
/*	glPointSize( 5.0f );
	for( int o = 0; o < aniRoot.iCountJoints; o ++ )
	{
		aniRoot.joiData[ o ].vVec.VecZero();
		aniRoot.joiData[ o ].vVec.VecMatrix( bonData[ o ].mAbs );

		glBegin( GL_POINTS );
			glVertex3fv( ( float * )&aniRoot.joiData[ o ].vVec );
		glEnd();
	}*/
}