#ifndef		_MGFMODEL_H
#define		_MGFMODEL_H

#include	<stdio.h>

#include	"Vector.h"
#include	"Matrix.h"
#include	"Texture.h"

typedef struct	_strcMGFVertex
{
	c_vector3d	vPos;
	c_vector2d	vTex;
	c_vector3d	vCol;

	int			iBone;
}				strcMGFVertex;

typedef	struct	_strcMGFTriangle
{
	strcMGFVertex	v[ 3 ];
}				strcMGFTriangle;

typedef struct	_strcMGFMaterial
{
	int			* iInd;
	int			iCountTriangles;
	mgcTexture	tex;
}				strcMGFMaterial;

typedef struct	_strcMGFJoint
{
	int			iParent;

	c_vector3d	vPos;
	c_vector3d	vRot;

	c_vector3d	vVec;
}				strcMGFJoint;

typedef struct	_strcMGFBone
{
	clMatrix	mRel;
	clMatrix	mAbs;
}				strcMGFBone;

typedef struct	_strcMGFFrame
{
	strcMGFJoint	* joiData;
}				strcMGFFrame;

typedef struct	_strcMGFAnimate
{
	strcMGFFrame	* frmData;
	int				iCountFrames;
}				strcMGFAnimate;

class	mgcMGFModel
{

public:

	strcMGFTriangle	* triData;
	strcMGFMaterial	* matData;
	strcMGFBone		* bonData;
	strcMGFAnimate	aniData;
	strcMGFFrame	aniRoot;
	c_vector3d		* vRenPos;
	int				iCountTriangles;
	int				iCountMaterials;
	int				iCountJoints;

	int				iCurrentFrame;

	float			fTimePerFrame;
	float			fTempTime;
	bool			bPlayAnimation;

					mgcMGFModel	( void );
	~				mgcMGFModel	( void );

	void			funCalculateMatrix	( strcMGFFrame ani );
	void			funCollapse		( void );
	void			funCreate		( void );

	void			funLoadModel		( char * chFileName );
	void			funLoadAnimation	( char * chFileName );

	void			funSetAnimation		( int iCurrentFrame, float fTimePerFrame );

	void			funRender		( float fDelTime );

private:

};

#endif		// _MGFMODEL_H