#include		<windows.h>

#include		<stdio.h>
#include		<conio.h>

typedef struct	_strcVertex
{
	int			iBone;
	float		px, py, pz;
	float		nx, ny, nz;
	float		u, v;
}				strcVertex;

typedef struct	_strcMaterial
{
	char		chName[ 64 ];
	int			iIndex[ 4096 ];
	int			iCountTriangles;
}				strcMaterial;

typedef struct	_strcJoint
{
	float		xp, yp, zp;
	float		xr, yr, zr;
}				strcJoint;

void FileSkipQuotes	( FILE * inpfile )
{
	int		iQuotes = 0;
	char	chChar;

	while( iQuotes < 2 )
	{
		chChar = 0;

		fread( &chChar, 1, 1, inpfile );

		if( chChar == '"' )
		{
			iQuotes ++;
		}
	}
}

int main()
{
	FILE	* inpfile;
	char	chFileName[ 256 ];

	printf( "Enters SMD file -> " );
	scanf( "%s", chFileName );

	inpfile = fopen( chFileName, "r" );

	if( inpfile )
	{
		FILE	* resfile;
		char	chLine[ 256 ];
		strcVertex	vGet;
		int		i, j, k;
		long	l;
		strcMaterial	mat[ 24 ];
		int				iCountMaterials = 0;
		int				iCountBones = 0;
		bool			bFound = false;
		int				iIndBone[ 512 ];
		strcJoint		joiData[ 512 ];
		int				iCountJoints = 0;

		bool			bTriangle = false;
		bool			bNode = false;
		bool			bJoint = false;

		resfile = fopen( "result.txt", "w" );

		while( !feof( inpfile ) )
		{
			memset( &chLine, 0, 256 );
			fscanf( inpfile, "%s", &chLine );

			if( !strcmp( chLine, "triangles" ) && !bTriangle)
			{
				j = 0;
				k = 0;

				l = ftell( inpfile );

				memset( &chLine, 0, 256 );
				while( strcmp( chLine, "end" ) )
				{
					fscanf( inpfile, "%s", &chLine );

					// materials
					bFound = false;
					for( i = 0; i < iCountMaterials; i ++ )
					{
						if( !strcmp( chLine, mat[ i ].chName ) )
						{
							bFound = true;
							break;
						}
					}

					if( !bFound )
					{
						strcpy( mat[ iCountMaterials ].chName, chLine );
						mat[ iCountMaterials ].iCountTriangles = 0;
						iCountMaterials ++;
						k = 0;
					}

					mat[ iCountMaterials - 1 ].iCountTriangles ++;
					mat[ iCountMaterials - 1 ].iIndex[ k ] = j;

					// end materials

					for( i = 0; i < 3; i ++ )
					{
						fscanf( inpfile, "%i %f %f %f %f %f %f %f %f", 
							&vGet.iBone, 
							&vGet.px, 
							&vGet.py, 
							&vGet.pz,
							&vGet.nx,
							&vGet.ny,
							&vGet.nz,
							&vGet.u,
							&vGet.v );
					}

					j ++;
					k ++;
				}

				fprintf( resfile, "%i\n", j );

				fseek( inpfile, l, SEEK_SET );

				memset( &chLine, 0, 256 );
				while( strcmp( chLine, "end" ) )
				{
					fscanf( inpfile, "%s", &chLine );

					for( i = 0; i < 3; i ++ )
					{
						fscanf( inpfile, "%i %f %f %f %f %f %f %f %f", 
							&vGet.iBone, 
							&vGet.px, 
							&vGet.py, 
							&vGet.pz,
							&vGet.nx,
							&vGet.ny,
							&vGet.nz,
							&vGet.u,
							&vGet.v );

						fprintf( resfile, "%i %f %f %f %f %f\n", 
							vGet.iBone, 
							vGet.px, 
							vGet.py, 
							vGet.pz,
							vGet.u,
							vGet.v );
					}
				}

				fseek( inpfile, 0, SEEK_SET );

				bTriangle = true;
			}

			if( !strcmp( chLine, "nodes" ) && !bNode)
			{
				iCountBones = 0;

				while( strcmp( chLine, "end" ) )
				{
					memset( &chLine, 0, 256 );
					fscanf( inpfile, "%s", &chLine );

					if( !strcmp( chLine , "end" ) )
					{
						continue;
					}

					FileSkipQuotes( inpfile );
					fscanf( inpfile, "%i", &iIndBone[ iCountBones ] );
					iCountBones ++;
				}

				bNode = true;
			}

			if( !strcmp( chLine, "skeleton" ) && !bJoint)
			{
				iCountJoints = 0;
				fscanf( inpfile, "%s %s", &chLine, &chLine );

				while( strcmp( chLine, "end" ) )
				{
					memset( &chLine, 0, 256 );
					fscanf( inpfile, "%s", &chLine );

					if( !strcmp( chLine , "end" ) )
					{
						continue;
					}

					fscanf( inpfile, "%f %f %f %f %f %f", 
						&joiData[ iCountJoints ].xp,
						&joiData[ iCountJoints ].yp,
						&joiData[ iCountJoints ].zp,
						&joiData[ iCountJoints ].xr,
						&joiData[ iCountJoints ].yr,
						&joiData[ iCountJoints ].zr );

					iCountJoints ++;
				}

				bJoint = true;
			}
		}

		fprintf( resfile, "%i\n", iCountMaterials - 1 );
		for( i = 0; i < iCountMaterials - 1; i ++ )
		{
			fprintf( resfile, "%s\n", mat[ i ].chName );
			fprintf( resfile, "%i\n", mat[ i ].iCountTriangles );

			for( j = 0; j < mat[ i ].iCountTriangles; j ++ )
			{
				fprintf( resfile, "%i\n", mat[ i ].iIndex[ j ] );
			}
		}

		fprintf( resfile, "%i\n", iCountBones );
		for( i = 0; i < iCountBones; i ++ )
		{
			fprintf( resfile, "%i %f %f %f %f %f %f\n", iIndBone[ i ],
				joiData[ i ].xp, joiData[ i ].yp, joiData[ i ].zp,
				joiData[ i ].xr, joiData[ i ].yr, joiData[ i ].zr );
		}
		
		fclose( resfile );
		fclose( inpfile );
	}

	return 0;
}