#include		"SMDModel.h"

mgcSMDModel::mgcSMDModel( void )
{
	memset( &aniRoot, 0, sizeof( aniRoot ) );
	bFirstFrame = false;
	iFrame = 0;
}

mgcSMDModel::~mgcSMDModel( void )
{
	int			i;

	free( aniRoot.joiData );
	for( i = 0; i < iCountAnimate; i ++ )
	{
		free( aniData[ i ].joiData );
	}
	free( curData.bonData );
}

void mgcSMDModel::funFileSkipQuotes( FILE * infile )
{
	int		iQuote = 0;
	char	chLine;
	
	while( iQuote < 2 )
	{
		chLine = 0;

		fread( &chLine, 1, 1, infile );
		
		if( chLine == '"')
		{
			iQuote ++;
		}
	}
}

void mgcSMDModel::funLoad( char * chFileName )
{
	FILE	* infile;
	char	chLine[ 256 ];
	int		i, j;
	int		iCurPos;

	infile = fopen( chFileName, "r" );

	if( infile )
	{
		while( !feof( infile ) )
		{
			fscanf( infile, "%s", chLine );

			// - > NODES ->
			// Calculate number of nodes
			if( !strcmp( chLine, "nodes" ) )
			{
				iCurPos = ftell( infile );

				while( strcmp( chLine, "end" ) )
				{
					fscanf( infile, "%s", &chLine );
					if( !strcmp( chLine, "end" ) )
					{
						continue;
					}

					// Read name current joint
					funFileSkipQuotes( infile );

					// Read necessary number
					fscanf( infile, "%i", &j );
					aniRoot.iCountJoints ++;
				}

				// Set position in start chunk of nodes
				fseek( infile, iCurPos, SEEK_SET );
				memset( chLine, 0, sizeof( chLine ) );
				i = 0;
				// Allocate memory
				aniRoot.joiData = new mgcSMDJoint[ aniRoot.iCountJoints ];
				curData.bonData = new mgcSMDBone[ aniRoot.iCountJoints ];

				while( strcmp( chLine, "end" ) )
				{
					fscanf( infile, "%s", &chLine );
					if( !strcmp( chLine, "end" ) )
					{
						continue;
					}

					// Read name current joint
					funFileSkipQuotes( infile );

					// Readn need number
					fscanf( infile, "%i", &j );
					aniRoot.joiData[ i ].iParent = j;
					i ++;
				}
			}
			// < - NODES < -

			// Loading skeleton
			if( !strcmp( chLine, "skeleton" ) )
			{
				i = 0;

				while( strcmp( chLine, "end" ) )
				{
					fscanf( infile, "%s", &chLine );

					if( !strcmp( chLine, "end" ) )
					{
						continue;
					}

					if( !strcmp( chLine, "time" ) )
					{
						fscanf( infile, "%s", &chLine );
						fscanf( infile, "%s", &chLine );
					}

					fscanf( infile, "%f %f %f %f %f %f", 
						    &aniRoot.joiData[ i ].vTrn.x, 
							&aniRoot.joiData[ i ].vTrn.y, 
							&aniRoot.joiData[ i ].vTrn.z,
							&aniRoot.joiData[ i ].vRot.x,
							&aniRoot.joiData[ i ].vRot.y,
							&aniRoot.joiData[ i ].vRot.z );

					i ++;
				}
			}

			// Loading triangles
			if( !strcmp( chLine, "triangles" ) )
			{
				while( strcmp( chLine, "end" ) )
				{
					fscanf( infile, "%s", &chLine );

					if( strcmp( chLine, "end" ) )
					{
						sprintf( triData[ iCountTriangles ].chTexName, chLine );

						if( !funExistTexture( triData[ iCountTriangles ].chTexName ) )
						{
							funAddTexture( triData[ iCountTriangles ].chTexName );
						}
					}
					
					for( int i = 0; i < 3; i ++ )
					{
						fscanf( infile, "%i %f %f %f %f %f %f %f %f", 
								&triData[ iCountTriangles ].vVer[ i ].iBone,
							    &triData[ iCountTriangles ].vVer[ i ].vPos.x,
								&triData[ iCountTriangles ].vVer[ i ].vPos.y,
								&triData[ iCountTriangles ].vVer[ i ].vPos.z,
								&triData[ iCountTriangles ].vVer[ i ].vNor.x,
								&triData[ iCountTriangles ].vVer[ i ].vNor.y,
								&triData[ iCountTriangles ].vVer[ i ].vNor.z,
								&triData[ iCountTriangles ].vVer[ i ].vTex.x,
								&triData[ iCountTriangles ].vVer[ i ].vTex.y );
					}

					iCountTriangles ++;
				}
			}
		}

		fclose( infile );
	}
}

void mgcSMDModel::funLoadAnimation( char * chFileName )
{
	FILE	* infile;
	char	chLine[ 256 ];
	int		i;

	infile = fopen( chFileName, "r" );

	if( infile )
	{
		while( !feof( infile ) )
		{
			fscanf( infile, "%s", chLine );

			if( !strcmp( chLine, "skeleton" ) )
			{
				i = 0;

				while( strcmp( chLine, "end" ) )
				{
					fscanf( infile, "%s", chLine );

					if( !strcmp( chLine, "time" ) )
					{
						fscanf( infile, "%i", &iCountAnimate );
						fscanf( infile, "%s", chLine );
						aniData[ iCountAnimate ].joiData = new mgcSMDJoint[ aniRoot.iCountJoints ];

						i = 0;
					}

					fscanf( infile, "%f %f %f %f %f %f", 
							&aniData[ iCountAnimate ].joiData[ i ].vTrn.x, 
							&aniData[ iCountAnimate ].joiData[ i ].vTrn.y, 
							&aniData[ iCountAnimate ].joiData[ i ].vTrn.z,
							&aniData[ iCountAnimate ].joiData[ i ].vRot.x,
							&aniData[ iCountAnimate ].joiData[ i ].vRot.y,
							&aniData[ iCountAnimate ].joiData[ i ].vRot.z );

					if( !i )	// If root bone then current root bone set base skeleton
					{
						aniData[ iCountAnimate ].joiData[ i ] = aniRoot.joiData[ i ];
					} 

					aniData[ iCountAnimate ].joiData[ i ].iParent = aniRoot.joiData[ i ].iParent;
					aniData[ iCountAnimate ].iCountJoints = aniRoot.iCountJoints;

					i ++;
				}
			}
		}

		fclose( infile );
	}
}

void mgcSMDModel::funCollapse( void )
{
	int		i, j;

	// Calculate new vertexes position
	for( i = 0; i < iCountTriangles; i ++ )
		for( j = 0; j < 3; j ++ )
		{
			triData[ i ].vVer[ j ].vPos.VecInvMatrix( curData.bonData[ triData[ i ].vVer[ j ].iBone ].mAbs );
		}
}

void mgcSMDModel::funBuild( void )
{
	int		i, j;

	// Calculate new vertexes position
	for( i = 0; i < iCountTriangles; i ++ )
		for( j = 0; j < 3; j ++ )
		{
			triData[ i ].vVer[ j ].vPos.VecMatrix( curData.bonData[ triData[ i ].vVer[ j ].iBone ].mAbs );
		}
}

void mgcSMDModel::funCalculateMatrix( mgcSMDAnimate mAni )
{
	clMatrix	mTmp;

	for( int i = 0; i < mAni.iCountJoints; i ++ )
	{
		curData.bonData[ i ].mAbs.clClear();

		curData.bonData[ i ].mRel.clCreateXYZRot( - mAni.joiData[ i ].vRot.x,
												  - mAni.joiData[ i ].vRot.y,
												  - mAni.joiData[ i ].vRot.z );

		curData.bonData[ i ].mRel.m[ 7  ] = mAni.joiData[ i ].vTrn.y;	
		curData.bonData[ i ].mRel.m[ 3  ] = mAni.joiData[ i ].vTrn.x;
		curData.bonData[ i ].mRel.m[ 11 ] = mAni.joiData[ i ].vTrn.z;
		

		if( mAni.joiData[ i ].iParent != - 1 )
		{
			curData.bonData[ i ].mAbs = curData.bonData[ mAni.joiData[ i ].iParent ].mAbs * curData.bonData[ i ].mRel;
		}
		else
		{
			curData.bonData[ i ].mAbs = curData.bonData[ i ].mRel;
		}
	}
}

void mgcSMDModel::funAnimate( void )
{
/*	if( !bFirstFrame )
	{
		funCalculateMatrix	( aniRoot );
		funCollapse			();
		bFirstFrame = true;
	}
	else
	{
		funCalculateMatrix	( aniData[ iFrame ] );
		funCollapse			();
	}

	fff += 0.1f;
	if( fff > 0.3f ){
	iFrame ++;
	fff = 0;
	}
	if(iFrame>iCountAnimate)iFrame = 0;

	funCalculateMatrix	( aniData[ iFrame ] );
	funBuild			();*/
}

void mgcSMDModel::funRender( void )
{
	int		i, j;

	glEnable( GL_TEXTURE_2D );
	glEnable( GL_DEPTH_TEST );
	glEnable( GL_CULL_FACE );
	glCullFace( GL_BACK );

	glColor4f( 1.0f, 1.0f, 1.0f, 1.0f);

	for( i = 0; i < iCountTriangles; i ++ )
	{
		funCallByNameTexture( triData[ i ].chTexName );
		glBegin( GL_TRIANGLES );

		for( j = 0; j < 3; j ++ )
		{
			glTexCoord2fv ( ( float * )&triData[ i ].vVer[ j ].vTex );
			glVertex3fv   ( ( float * )&triData[ i ].vVer[ j ].vPos );
		}

		glEnd();
	}

	glDisable( GL_CULL_FACE );
	glDisable( GL_DEPTH_TEST );
	glDisable( GL_TEXTURE_2D );
}

bool mgcSMDModel::funExistTexture( char * chName )
{
	for( int i = 0; i < iCountTextures; i ++ )
	{
		if( !strcmp( chName, texData[ i ].chName ) )
		{
			return true;
		}
	}

	return false;
}

void mgcSMDModel::funAddTexture( char * chName )
{
	sprintf( texData[ iCountTextures ].chName, chName );
	texData[ iCountTextures ].lTex.tLoadBMP( chName );

	iCountTextures ++;
}

void mgcSMDModel::funCallByNameTexture( char * chName )
{
	for( int i = 0; i < iCountTextures; i ++ )
	{
		if( !strcmp( chName, texData[ i ].chName ) )
		{
			texData[ i ].lTex.tCall();

			break;
		}
	}
}