#ifndef		_SMDMODEL_H
#define		_SMDMODEL_H

#include	"Vector.h"
#include	"Texture.h"

#include	<stdio.h>

class	mgcSMDVertex
{

public:

	c_vector3d	vPos;
	c_vector3d	vNor;
	c_vector2d	vTex;

	int			iBone;

private:
	
};

class	mgcSMDTriangle
{

public:

	mgcSMDVertex	vVer[ 3 ];
	char			chTexName[ 64 ];

private:

};

class	mgcSMDTexture
{

public:

	mgcTexture	lTex;
	char		chName[ 64 ];

private:

};

class	mgcSMDJoint
{

public:

	int		iParent;

	c_vector3d	vTrn;
	c_vector3d	vRot;

private:

};

class	mgcSMDBone
{

public:

	clMatrix	mRel;
	clMatrix	mAbs;

private:

};

class	mgcSMDAnimate
{

public:

	mgcSMDJoint	* joiData;
	int			iCountJoints;

private:

};

class	mgcSMDMatrix
{

public:

	mgcSMDBone	* bonData;

private:

};

class	mgcSMDModel
{

public:

	mgcSMDTriangle	triData[ 2048 ];
	int				iCountTriangles;
	mgcSMDTexture	texData[ 10 ];
	int				iCountTextures;

	mgcSMDMatrix	curData;	// Current matrixes
	mgcSMDAnimate	aniRoot;	// Base skeleton of model
	mgcSMDAnimate	aniData[ 64 ];	// Rotation and transtation joints
	int				iCountAnimate;	// Count frames of animation
	bool			bFirstFrame;
	int				iFrame;
	float			fff;

					mgcSMDModel	( void );
	~				mgcSMDModel	( void );

	// Functions for work with file
	void			funFileSkipQuotes	( FILE * infile );

	// more
	void			funLoad	( char * chFileName );
	void			funLoadAnimation	( char * chFileName );
	void			funCollapse			( void );
	void			funCalculateMatrix	( mgcSMDAnimate mAni );
	void			funBuild			( void );
	void			funAnimate	( void );
	void			funRender	( void );

	bool			funExistTexture	( char * chName );
	void			funAddTexture	( char * chName );
	void			funCallByNameTexture	( char * chName );

private:

};

#endif		// _SMDMODEL_H