#ifndef		_VECTOR_H
#define		_VECTOR_H

/*
 * =================================================================================================
 * Vector 2d
 * =================================================================================================
 */

#include		"Matrix.h"

class c_vector3d;		// Forward declaration

class c_vector2d
{

public:

	float		x, y;

				c_vector2d	( void );
				c_vector2d	( float fx, float fy );

	void		operator += ( c_vector2d vVector );
	void		operator -= ( c_vector2d vVector );
	void		operator *= ( c_vector2d vVector );
	void		operator /= ( c_vector2d vVector );

	void		operator += ( float fValue );
	void		operator -= ( float fValue );
	void		operator *= ( float fValue );
	void		operator /= ( float fValue );

	c_vector2d	operator +	( c_vector2d vVector );
	c_vector2d	operator -	( c_vector2d vVector );
	c_vector2d	operator *	( c_vector2d vVector );
	c_vector2d	operator /	( c_vector2d vVector );

	c_vector2d	operator +	( float fValue );
	c_vector2d	operator -	( float fValue );
	c_vector2d	operator *	( float fValue );
	c_vector2d	operator /	( float fValue );

	void		operator =	( c_vector3d vVector );

	float		operator []	( int iIndex );

	void		VecSet		( float fx, float fy );
	void		VecZero		( void );
	void		VecNormalize	( void );

	float		DotProduct	( c_vector2d vVector );
	float		CosBetween	( c_vector2d vVector );

	c_vector2d	PerpVector	( void );
	c_vector2d	GetNormal	( void );

	float		GetLength	( void );
	float		GetQLength	( void );

	void		VecReflect	( c_vector2d vVector );
	void		VecRotate	( float fAngle );

private:

};

/*
 * =================================================================================================
 * Vector 3d
 * =================================================================================================
 */


class c_vector3d
{

public:

	float		x, y, z;

				c_vector3d	( void );
				c_vector3d	( float fx, float fy, float fz );

	void		operator += ( c_vector3d vVector );
	void		operator -= ( c_vector3d vVector );
	void		operator *= ( c_vector3d vVector );
	void		operator /= ( c_vector3d vVector );

	void		operator += ( float fValue );
	void		operator -= ( float fValue );
	void		operator *= ( float fValue );
	void		operator /= ( float fValue );

	c_vector3d	operator +	( c_vector3d vVector );
	c_vector3d	operator -	( c_vector3d vVector );
	c_vector3d	operator *	( c_vector3d vVector );
	c_vector3d	operator /	( c_vector3d vVector );

	c_vector3d	operator +	( float fValue );
	c_vector3d	operator -	( float fValue );
	c_vector3d	operator *	( float fValue );
	c_vector3d	operator /	( float fValue );

	void		operator =	( c_vector2d vVector );

	float		operator []	( int iIndex );

	void		VecSet		( float fx, float fy, float fz );
	void		VecZero		( void );
	void		VecNormalize	( void );

	float		DotProduct	( c_vector3d vVector );
	float		CosBetween	( c_vector3d vVector );

	c_vector3d	CrossProduct	( c_vector3d vVector );
	c_vector3d	GetNormal		( c_vector3d vVector );

	float		GetLength	( void );

	void		VecRotateX	( float fAng );
	void		VecRotateY	( float fAng );
	void		VecRotateZ	( float fAng );

	void		VecRotAxis	( c_vector3d vAxis, float fAngle );

	void		VecMatrix	( clMatrix m );
	void		VecInvMatrix	( clMatrix m );

private:

};

#endif		// _VECTOR_H